#!/usr/bin/python
# -*- coding: utf-8 -*-
"""
__version__ = "$Revision: 1.14 $"
__date__ = "$Date: 2008/11/18 20:38:45 $"

    This file is part of Mazrim software.

    Mazrim is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    Mazrim is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with Mazrim.  If not, see <http://www.gnu.org/licenses/>.

"""

from PythonCard import model, dialog, clipboard
import re, sys, subprocess,time, getpass,os,gettext,string
from urllib import urlopen


#internalization
gettext.install('Mazrim_1', '/usr/lib/Mazrim/locale', unicode=False)

he = gettext.translation('Mazrim', '/usr/lib/Mazrim/locale', languages=['he']) # Hebrew
#en = gettext.translation('Mazrim', '/usr/lib/Mazrim/locale', languages=['en']) # English

mazrim_version = "1.9\n"
version_check_url = "http://ilsh.info/mazrimver"


def get_mms(all_lines,station): # this function return the mms address of the selected radio station
        found = False
        i = 0
        listLen=len(all_lines)
        themms=''
        while (not found) and (i < listLen):
                if station in all_lines[i]:
                        found = True
                        themms=all_lines[i].split()
                else:
                        i=i+1
        if found:
                return themms[1]
        else:
                return -1

def get_mediaPlayer():
        try:
                in_file=open("/etc/mazrim.conf","r")
        except:
                pass
        all_lines=in_file.readlines()
        in_file.close()
        return get_mms(all_lines,'mediaplayer')
           
def showVideo(list): # Common code to view video / Listen to the radio
        mediaPlayer=[]
        mediaPlayer.append(get_mediaPlayer())
        null = open('/dev/null', 'w')
        subprocess.Popen(mediaPlayer + list, stderr = null)

def showLongVideo(list,startTime,stopTime): # Common code to view video / Listen to the radio
        mediaPlayer=[]
        mediaPlayer.append(get_mediaPlayer())
        options = []
        options.extend([list , '--start-time=' + str(startTime), '--stop-time=' + str(stopTime)])
        
        null = open('/dev/null', 'w')
        subprocess.Popen(mediaPlayer + options, stderr = null)       

def process(input):
        if 'ynet.co.il' in input:
                html = urlopen(input).read()
                a = re.compile(r"""src=.(http://players.mediazone.co.il/media/authors/\d+/playlists/(\d+)/)""")
                b = re.finditer(a, html)
                for x in b:   
                        b1 = x.group(1) + x.group(2) + '_static.asx'
                        x1=x.group(1)
                        x2=x.group(2)
                        html = urlopen(b1).read()
                        re_link = re.compile('mms://\S*.wmv')
                        list=re_link.findall(html)
                        print list
                        if len(list) >= 4:
                            del list[0]
                            del list[0]
                showVideo(list)
                return (1)
        elif  'http://www.one.co.il/MSites/99/topshows.aspx' in input:
                b=[]
                b.append('http://media2.one.co.il/99')
                showVideo(b)
                return (1)
        elif  ('one.co.il/MSites/99' in input) or ('one.co.il/Msites/99' in input):
                html = urlopen(input).read()
                a = re.compile('http\S*GetClip.aspx\Sid=\d*')
                b = a.findall(html)
                if b <> []:
                        new_html=urlopen(b[0]).read()
                        a=re.compile('mms://\S*wmv')
                        b=a.findall(new_html)
                showVideo(b)
                return (1)
        elif  'one.co.il' in input:
                exp = re.compile(r'''src="/cat/video/preview\.aspx\?VideoID=(\d+).*ImageURL=\d+_(\d+)_(\d+)_''', re.IGNORECASE)
                html = urlopen(input).read()
                a = re.finditer(exp, html)
                list = []
                for match in a:
                        url = 'mms://media1.one.co.il/%s_%s/%s.wmv' % (match.group(3), int(match.group(2)), match.group(1))
                        list.append(url)
                showVideo(list)
                return (1)
        elif 'yes.walla.co.il' in input:
                html = urlopen(input).read()
                html_page = re.compile('http\S*asx')
                asx_file = html_page.findall(html)
                new_html=urlopen(asx_file[0]).read()
                a=re.compile('mms\S*wmv')
                b=a.findall(new_html)
                showVideo(b)
                return (1)
        elif 'walla.co.il' in input:
                html = urlopen(input).read()
                html_page = re.compile('http\S*asx')
                asx_file = html_page.findall(html)
                new_html=urlopen(asx_file[0]).read()
                list=[]
                if 'WMV' in new_html:
                        a=re.compile('mms\S*WMV')
                        b=a.findall(new_html)
                        list.append(b[0])
                else:
                        a=re.compile('mms\S*wmv')
                        b=a.findall(new_html)
                        list.append(b[1])
                showVideo(list)
                return (1)
        elif 'nrg.co.il' in input:
                html = urlopen(input).read()
                a = re.compile('http://switch\S*ak=null')
                b = re.findall(a, html)
                html = urlopen(b[0]).read()
                a = re.compile('http://switch\S*ak=null')
                b = re.findall(a, html)
                list=[]
                html = urlopen(b[1]).read()
                a = re.compile('mms://\w*.\w*.\w*/\w*/\w*-\w*.wmv')
                c = re.findall(a, html)
                for each_mms in c:
                    list.append(each_mms)
                try:
                    html = urlopen(b[2]).read()
                    a = re.compile('mms://\w*.\w*.\w*/\w*/\w*-\w*.wmv')
                    b = re.findall(a, html)
                    for each_mms in b:
                        list.append(each_mms)
                except:
                    pass
                showVideo(list)
                return (1)
        elif 'sport5.co.il' in input:
                html = urlopen(input).read()
                a1 = re.compile('ClipMediaID\S*\d\d\d\d\S*null')
                b = re.findall(a1, html)
                list=[]
                for eachClip in b:
                        a2 = re.compile('\d+\d+\d+\d+\d+')
                        c=re.findall(a2,eachClip)
                        new_url='http://switch308-01.castup.net/cunet/gm.asp?ClipMediaID='+c[0]+'&ak=null'
                        html = urlopen(new_url).read()
                        a3=re.compile('mms\S*wmv')
                        b1 = re.findall(a3, html)
                        list=list+b1
                showVideo(list)
                return (1)			
        elif 'music24.co.il' in input:
                clipID=re.compile('\d\d\d\d')
                clip_number=clipID.findall(input)
                new_url="http://www.music24.co.il/videoplayer.aspx?vidID="+clip_number[0]+"&showLabel=1&autoplay=1&click=1\r\n"
                html = urlopen(new_url).read()
                html_page = re.compile('http://switch3.castup.net/\S*ClipMediaID=\d*\S*vidID=\d*')
                asx_file = html_page.findall(html)
                new_html=urlopen(asx_file[0]).read()
                a=re.compile('mms\S*wmv')
                b=a.findall(new_html)
                list=[]
                list.append(b[1])
                showVideo(list)
                return (1)
        elif 'mako.co.il/news' in input:
                html = urlopen(input).read()
                a = re.compile('http://www.mako.co.il/\S*playerASX.jsp\?asx=\S*=null')
                b = re.findall(a, html)
                html = urlopen(b[0]).read()
                a = re.compile('http://switch\d*-\d*.castup.net\S*gm.asp\S*ak=null')
                b = re.findall(a, html)
                html = urlopen(b[0]).read()
                a = re.compile('mms://\S*.wmv')
                b = re.findall(a, html)
                showVideo(b)
                return (1)
        elif ('keshet-tv.com/Ambatia' in input) or ('keshet-tv.com/ambatia' in input):
                html = urlopen(input).read()
                a=re.compile('http://switch248-01.castup.net/cunet/gm.asp\S*ak=null')
                newURL=re.findall(a,html)
                html = urlopen(newURL[0]).read()
                a=re.compile('mms\S*wmv')
                b = re.findall(a, html)    
                showVideo(b)
                return (1)
        elif 'mooma.keshet-tv.com' in input:
                html = urlopen(input).read()
                a=re.compile('MediaID=\d\d\d\d\d')
                tmpID=re.findall(a,html)
                findMediaNum=re.compile('\d\d\d\d\d')
                mediaID=re.findall(findMediaNum,tmpID[0])
                newURL='http://www.keshet-tv.com/Common/ClickPlay.aspx?MediaID='+mediaID[0]
                html = urlopen(newURL).read()
                a=re.compile('http://\S*=\d\d\d\d\d')
                newURL=re.findall(a,html)
                html = urlopen(newURL[0]).read()
                a=re.compile('mms\S*wmv')
                b = re.findall(a, html)
                showVideo(b)
                return (1)
        elif (('nana10.co.il' in input) and ('ArticleID' in input) ):
                html = urlopen(input).read()
                a1 = re.compile('VideoID=\d\d\d\d\d')
                b = re.findall(a1, html)
                new_url='http://net.nana10.co.il/Video/?'+b[0]
                html = urlopen(new_url).read()
                a1 = re.compile('http://\S*ak=null\S*')
                b = re.findall(a1, html)
                a1 = re.compile('ClipMediaID=\d*')
                clipMediaID = re.findall(a1,b[1])
                a1 = re.compile('http://\S*gm.asp?')
                linkPrefix = re.findall(a1,b[1])
                new_link=linkPrefix[0]+'?'+clipMediaID[0]
                the_link=[]
                the_link.append(new_link)

                # Calculate start and stop time
                a1 = re.compile('\d\d:\d\d:\d\d')
                stime = re.findall(a1,b[1])
                if stime == []:
                        html=urlopen(the_link[0]).read()
                        a=re.compile('http\S*wmv')
                        b = re.findall(a, html)
                        showVideo(b)
                        return (1)
                else:
                        times = string.split(stime[0],':')
                        startTime=int(times[0])*3600 + int(times[1])*60 + int(times[2])
                        times = string.split(stime[1],':')
                        stopTime = startTime + int(times[0])*3600 + int(times[1])*60 + int(times[2])
                        showLongVideo(the_link[0], startTime,stopTime)
                        return (1)			
        elif ('darom_tv_' in input):
                html = urlopen(input).read()
                html_page = re.compile('http://switch\S*ak=null')
                asx_file = html_page.findall(html)
                new_html=urlopen(asx_file[0]).read()
                a=re.compile('mms\S*wmv')
                b=a.findall(new_html)
                showVideo(b)
                return (1)			
        elif ('castup.net' in input):
                # Extend support for http://www.soprt5.co.il (video zone)
                html_page = re.compile('http://SWITCH\S*=null')
                correct_link=html_page.findall(input)
                new_html = urlopen(correct_link[0]).read()
                a=re.compile('mms\S*wmv')
                b=a.findall(new_html)
                showVideo(b)
                return (1)			
        elif ('2eat.co.il' in input):
                html = urlopen(input).read()
                html_page = re.compile('http://switch\S*ClipMediaID\S*ak=null')
                correct_link=html_page.findall(html)
                new_html = urlopen(correct_link[0]).read()
                a=re.compile('mms\S*wmv')
                b=a.findall(new_html)
                showVideo(b)
                return (1)
        elif ('www.cast-tv.biz' in input):
                # mouse.co.il site support
                html = urlopen(input).read()
                html_page = re.compile('mms\S*wmv')
                b=html_page.findall(html)
                showVideo(b)
                return (1)
        elif ('inn.co.il' in input):
                html = urlopen(input).read()
                html_page = re.compile('mms\S*wmv')
                b=html_page.findall(html)
                showVideo(b)
                return (1)
        elif ('zap.co.il' in input):
                newUrl=string.split(input,'#')
                html = urlopen(newUrl[0]).read()
                a = re.compile('http://switch5.castup.net/customers/zap/\S*null')
                b = a.findall(html)
                html = urlopen(b[0]).read()
                a = re.compile('http://switch\d*.castup.net/cunet/gm.asp?\S*ak=null')
                b = a.findall(html)
                html = urlopen(b[0]).read()
                a=re.compile('mms://\S*wmv')
                b=a.findall(html)
                showVideo(b)
                return (1) 
        elif ('hapoel.co.il' in input):
                html = urlopen(input).read()
                a = re.compile('http://www.Hapoel.co.il/VidPlayer.asp\?VID=\d*')
                b = re.findall(a, html)
                html = urlopen(b[0]).read()
                a = re.compile('http://www.Hapoel.co.il/pics/ASX/\d*.asx')
                b = re.findall(a, html)
                html=urlopen(b[0]).read()
                a=re.compile('http://\S*clipid=\d*')
                b = re.findall(a, html)
                html=urlopen(b[0]).read()
                a=re.compile('mms://\S*.wmv')
                b = re.findall(a, html)
                showVideo(b)
                return (1)
        elif ('http://actv.haifa.ac.il/programs' in input):
                html = urlopen(input).read()
                html_page = re.compile('mms\S*wmv')
                b=html_page.findall(html)
                showVideo(b)
                return (1)
        else:	
                return (0)
        
class Mazrim (model.Background):
        def on_initialize(self, event):
                if (len(sys.argv)>1) and  (sys.argv[1]!="about:blank"):
                        self.components.urlArea1.text = sys.argv[1]                                
                else:
                        self.components.urlArea1.text = ""
                        
        def on_pasteAndGoButton_mouseClick(self, event):
                self.components.urlArea1.text = clipboard.getClipboard()
                self.components.urlArea1.setFocus()		
                if not process(self.components.urlArea1.text):
                        self.components.urlArea1.setFocus()	
                        self.components.urlArea1.text = clipboard.getClipboard()
                        time.sleep(1)
                        self.components.urlArea1.text = _(u'Sorry. not yet supported ...')

        def on_ListenButton_mouseClick(self, event):
                try:
                        in_file=open("/etc/mazrim.conf","r")
                except:
                        self.components.urlArea1.text = _(u"Error: Missing 'mazrim.conf' file")
                        
                all_lines=in_file.readlines()
                in_file.close()

                Reshet_Bet=get_mms(all_lines,'Reshet_Bet')
                Reshet_Gimel=get_mms(all_lines,'Reshet_Gimel')
                Gal_Galatz=get_mms(all_lines,'Gal_Galatz')
                Galey_Zahal=get_mms(all_lines,'Galey_Zahal')
                Radio_88FM=get_mms(all_lines,'Radio_88FM')
                Radio_103FM=get_mms(all_lines,'Radio_103FM')
                Radio_Jerusalem=get_mms(all_lines,'Radio_Jerusalem')
                Channel_7=get_mms(all_lines,'Channel_7')
                Radio_Haifa=get_mms(all_lines,'Radio_Haifa')
                Kol_Hamuzika=get_mms(all_lines,'Kol_Hamuzika')
                Kol_Hakampus=get_mms(all_lines,'Kol_Hakampus')
                Radio_102FM=get_mms(all_lines,'Radio_102FM')
                Radio_91FM=get_mms(all_lines,'Radio_91FM')
                Radius_100FM=get_mms(all_lines,'Radius_100FM')
                
                if ((Reshet_Bet==-1) or (Reshet_Gimel==-1) or (Gal_Galatz==-1) or (Galey_Zahal==-1)or (Radio_88FM==-1)or (Radio_103FM==-1) or (Radio_Jerusalem==-1) \
                    or (Channel_7==-1)or (Radio_Haifa==-1)or (Kol_Hamuzika==-1)or (Kol_Hakampus==-1) or (Radio_91FM==-1) or (Radius_100FM==-1) or (Radio_102FM==-1)):
                        self.components.urlArea1.text = _(u"Error: At least one Radio station is missing in 'mazrim.conf' file")
                else:
                        station={_(u'Reshet_Bet'):Reshet_Bet,\
                                 _(u'Reshet_Gimel'):Reshet_Gimel,\
                                 _(u'Gal_Galatz'):Gal_Galatz,\
                                 _(u'Galey_Zahal'):Galey_Zahal,\
                                 _(u'Radio_88FM'):Radio_88FM,\
                                 _(u'Radio_103FM'):Radio_103FM,\
                                 _(u'Radio_Jerusalem'):Radio_Jerusalem,\
                                 _(u'Channel_7'):Channel_7,\
                                 _(u'Radio_Haifa'):Radio_Haifa,\
                                 _(u'Kol_Hamuzika'):Kol_Hamuzika,\
                                 _(u'Kol_Hakampus'):Kol_Hakampus,\
                                 _(u'Radio_91FM'):Radio_91FM,\
                                 _(u'Radius_100FM'):Radius_100FM,\
                                 _(u'Radio_102FM'):Radio_102FM}
                
                        self.components.urlArea1.text = _(u"Playing Radio... ('%s')") % self.components.Stations.stringSelection.encode("utf8")
                        the_station=[]
                        the_station.append(station[self.components.Stations.stringSelection.encode("utf8")])
                        showVideo(the_station)
         
        def on_LiveButton_mouseClick(self, event):
                try:
                        in_file=open("/etc/mazrim.conf","r")
                except:
                        self.components.urlArea1.text = _(u"Error: Missing 'mazrim.conf' file")
                        
                all_lines=in_file.readlines()
                in_file.close()

                Channel_1=get_mms(all_lines,'Channel_1')
                Channel_2=get_mms(all_lines,'Channel_2')
                Channel_10=get_mms(all_lines,'Channel_10')
                                
                if ((Channel_1==-1) or (Channel_2==-1) or (Channel_10==-1) ):
                        self.components.urlArea1.text = _(u"Error: At least one News station is missing in 'mazrim.conf' file")
                else:
                    station={_(u'Channel_1'):Channel_1,  _(u'Channel_2'):Channel_2, _(u'Channel_10'):Channel_10}
                    self.components.urlArea1.text = _(u"Playing Live News... ('%s')") % self.components.Lives.stringSelection.encode("utf8")
                    the_station=[]
                    the_station.append(station[self.components.Lives.stringSelection.encode("utf8")])
                    showVideo(the_station)
                
         

        def on_menuFileExit_select(self, event):
                self.close()

        def on_menuFileVersion_select(self, event):
                last_version = urlopen(version_check_url).read();
                if mazrim_version > last_version:
                        message = _(u"Mazrim: You are using a development version")
                elif mazrim_version == last_version:
                        message = _(u"Mazrim: You are using the lastest version'")
                else:
                        message = _(u"Mazrim: You are using an old version. Please upgrade!")
                title = _(u"Mazrim: Version Check")
                result = dialog.scrolledMessageDialog(self, message, title)
                
                
        def on_menuHelpAbout_select(self, event):
                message = _(u"Mazrim Version 1.9\n\nSupport video stream in these sites:\nhttp://www.one.co.il\nhttp://www.walla.co.il\nhttp://www.yes.co.il\nhttp://www.ynet.co.il\nhttp://www.nana10.co.il\nhttp://www.sport5.co.il\nhttp://www.nrg.co.il\nhttp://www.music24.co.il\nhttp://www.2eat.co.il\nhttp://www.mouse.co.il\nhttp://www.daromtv.com\nhttp://www.inn.co.il\nhttp://www.hapoel.co.il\nhttp://www.mako.co.il\nhttp://mooma.keshet-tv.com\nhttp://actv.haifa.ac.il\nhttp://zap.co.il\n\n\nLicence: GPL V2 (Warranty and limitation: In Readme.txt file) \nHomepage: http://mazrim.sourceforge.net/")
                title = _(u"Mazrim 1.9 - About")
                result = dialog.scrolledMessageDialog(self, message, title)

        def on_WatchButton_mouseClick(self, event):
                camera={_(u'Ayalon: Road1'):'mms://s08wm.castup.net/991450001-52.wmv', \
			_(u'Ayalon: Hagiborim'):'mms://s08wm.castup.net/991450016-52.wmv', \
			_(u'Ayalon: Volfson'):'mms://s08wm.castup.net/991450013-52.wmv', \
			_(u'Ayalon: Z-Holon'):'mms://s08wm.castup.net/991450002-52.wmv', \
			_(u'Ayalon: K-Galuiot'):'mms://s08wm.castup.net/991450003-52.wmv', \
			_(u'Ayalon: La-Gardia'):'mms://s08wm.castup.net/991450004-52.wmv', \
			_(u'Ayalon: Izhak-Sade'):'mms://s08wm.castup.net/991450005-52.wmv',\
			_(u'Ayalon: Hashalom'):'mms://s08wm.castup.net/991450006-52.wmv',\
			_(u'Ayalon: Arlozorov'):'mms://s08wm.castup.net/991450007-52.wmv',\
			_(u'Ayalon: Hahalacha'):'mms://s08wm.castup.net/991450008-52.wmv',\
			_(u'Ayalon: Rokach'):'mms://s08wm.castup.net/991450009-52.wmv',\
			_(u'Ayalon: Kakal'):'mms://s08wm.castup.net/991450010-52.wmv',\
			_(u'Ayalon: Glilot'):'mms://s08wm.castup.net/991450011-52.wmv',\
			_(u'Ayalon: Herzelia1'):'mms://s08wm.castup.net/991450012-52.wmv',\
			_(u'Ayalon: Herzelia2'):'mms://s08wm.castup.net/991450014-52.wmv',\
			_(u'Ayalon: Herzelia-Zafon'):'mms://s08wm.castup.net/991450015-52.wmv',\
                        _(u'Road_2: Rabin'):'http://212.25.110.152:7011/Stream7.asf',\
                        _(u'Road_4: Morasha'):'http://212.25.110.153:7011/Stream8.asf',\
                        _(u'Road_4: Gehaa'):'http://212.25.110.152:7011/Stream6.asf',\
                        _(u'Road_4: Bar Ilan'):'http://212.25.110.153:7011/Stream3.asf',\
                        _(u'Road_4: Aluf Sade'):'http://212.25.110.153:7011/Stream6.asf',\
                        _(u'Road_4: Mesubim'):'http://212.25.110.152:7011/Stream3.asf',\
                        _(u'Road_4: Ganot'):'http://212.25.110.153:7011/Stream2.asf',\
                        _(u'Road_4: Safirim'):'http://212.25.110.153:7011/Stream5.asf',\
                        _(u'Road_4: Bet Dagan'):'http://212.25.110.152:7011/Stream4.asf',\
                        _(u'Road_4: Hashivaa'):'http://212.25.110.152:7011/Stream2.asf',\
                        _(u'Road_4: Rashlatz'):'http://212.25.110.153:7011/Stream4.asf',\
                        _(u'Road_4: Bney Darom'):'http://212.25.110.152:7011/Stream1.asf',\
                        _(u'Road_5: Yarkon'):'http://212.25.110.153:7011/Stream7.asf',\
                        _(u'Road_5: Morasha'):'http://212.25.110.153:7011/Stream8.asf',\
                        _(u'Road_5: Glilot'):'http://212.25.110.153:7011/Stream1.asf'}
                self.components.urlArea1.text = _("Playing Road Camera... ('%s')") % self.components.Camera.stringSelection.encode("utf8")
                the_station=[]
                the_station.append(camera[self.components.Camera.stringSelection.encode("utf8")])
                showVideo(the_station)


                      
if __name__ == '__main__':
        if os.environ['LANG'].startswith("he_IL"):
                he.install()
        #else: en.install()
        if (len(sys.argv)==1)or((len(sys.argv)==2)and(sys.argv[1]=="about:blank")):
                app = model.Application(Mazrim)
                app.MainLoop()
        elif len(sys.argv)>1:
                args=sys.argv[1:]
                for url in args:
                        process(url)
        else:
                pass
